
-- definit inpustring, inputinteger, inputfloat

-- inputstring permet de faire rentrer une string,
-- les arguments sont line, column : les coordonnes de l'endroit o
-- le texte s'affiche lors de la saisie (coordonnes du curseur de print)
-- et maxchar est la taille maximale de la chaine  saisir

-- inputinteger(line, column,Nmin,Nmax,maxchar) permet de faire saisir un entier
-- on peut prciser les coordonnes de l'endroit o s'affiche la saisie,
-- ainsi que le nombre minimal/maximal attendu

-- de mme pour inputfloat, mais avec des flottants

-- TOUT les arguments de ces fonctions sont facultatifs (si vous ne mettez rien ou nil, il prendra la valeur par dfaut)


def ="module input"
local cursor=nbdraw.setcursor
local tonumber = base.tonumber
local wait=misc.wait

local strsub = string.sub

-- wt waits we stop pressing key t
local function wt(t)
 repeat wait(1) until not key(t)
 end





function scanf(isnum,Nmin,Nmax,line, column,Numberdep,tostring, maxchar, default, tiny, alternate)
local numberdep =Numberdep or (( ( (Nmin>0) and Nmin) or ( (Nmax<0) and Nmax) ) or 0)
local strndep = (isnum and tostring(numberdep)) or ""
local i
local minus = false
local alpha = false
-- the case i must be for the key i. if the case i is nil, then we are not in the set
local tch = default

local maxchara = maxchar or 40

local touche = 0
local number = numberdep
local strn = strndep
local nvalidate = true


cursor(line, column)
nbdraw.print(strn.."  ")

repeat
 nvalidate = true
 repeat

  touche = 0
  while touche == 0 do
   for i = 1,50,1 do
	if key(i) then touche =  i; break; end
   end
   -- test if we change of set
   if touche == 41	    then minus = not(minus);alpha = false; tch =( minus and alternate) or default ;touche = 0; wt(41)
   elseif touche == 33 then alpha = not(alpha);minus = false; tch =(alpha and tiny) or default ; touche = 0; wt(33)
   elseif touche == 36 then return nil -- we want to exit
   end
  end



  if tch[touche] and #strn <= maxchara then
	if isnum and strn == "0" then strn = tch[touche]
	else strn = strn .. tch[touche]
	end
	nvalidate = false
  elseif touche == 4 and isnum then -- we pressed '-'. handle the different cases
	if strsub(strn,-1)=="e" and #strn <= maxchara then strn=strn.."-"
	elseif strsub(strn,-1)=="-" then strn=strsub(strn,1,#strn-1)
	elseif strsub(strn,1,1) =="-" then strn = strsub(strn,2)
	elseif #strn <= maxchara then strn = "-"..strn	end
	nvalidate = false
  elseif touche == 19 -- we pressed del
	then if #strn == 1 and isnum then strn = "0" -- we must keep a number on screen
		elseif #strn ~= 0 then  strn=strsub(strn,1,#strn-1) end
	nvalidate = false
  end

  cursor(line, column)
  nbdraw.print(strn.."  ")
  wt(touche)
 until touche == 5


 if isnum
 then
    local clean = " "
    for i = 1,#strn do clean = clean .. " " end
    cursor(line, column)
    nbdraw.print (clean)
    number=tonumber(strn)
    if not(number) then number = 0 end --conversion failed
    strn=tostring(number)
    cursor(line, column)
    nbdraw.print(strn)
    wt(5)
 else
    nvalidate = true
	wt(5)
 end

until nvalidate
-- nvalidate is true when the calculator proposed an interpretation of the input and the user press exe without changing anything
return strn
end


function inputstring (line, column,maxchar)
local default =   {"Z"," ","\"","-",nil,"U","V","W","X","Y","P","Q","R","S","T","M","N","O",nil,nil,"G","H","I","J","K","L","A","B","C","D","E","F"}
local tiny =      {"z",".",nil,nil,nil,"u","v","w","x","y","p","q","r","s","t","m","n","o",nil,nil,"g","h","i","j","k","l","a","b","c","d","e","f"}
local alternate = {"0","=",nil,nil,nil,"1","2","3","+","-","4","5","6","x","/","7","8","9",nil,nil,"[","]","(",")",">","<","'",":","?",",","!" }
return scanf(false,nil,nil,line,column,0,nil,maxchar,default,tiny,alternate)
end

function inputinteger (line, column,Nmin,Nmax,maxchar)
nbdraw.precision(9)-- change the length of the result of base.tostring
local default = {"0",nil,nil,nil,nil,"1","2","3",nil,nil,"4","5","6",nil,nil,"7","8","9" }
local res = scanf(true, Nmin, Nmax, line, column, 0, misc.tostring2 ,maxchar, default)
nbdraw.precision(6)
if res then return base.tonumber(res)
else return nil -- we want to leave
end
end

function inputfloat (line,column,Nmin, Nmax,maxchar)-- every argument can be set to nothing or nil
nbdraw.precision(9)-- change the length of the result of base.tostring
local default = {"0",".","e",nil,nil,"1","2","3",nil,nil,"4","5","6",nil,nil,"7","8","9" }
local res = scanf(true, Nmin, Nmax, line, column, 0, base.tostring ,maxchar, default)
nbdraw.precision(6)
if res then return base.tonumber(res)
else return nil -- we want to leave
end
end


