local cursor = nbdraw.setcursor
local print = nbdraw.print
local wait = misc.wait
local copypage = nbdraw.copypage
local modload = misc.modload
local error = base.error

local function wait_no_press(t)
repeat wait(1) until not key(t)
end

-- load modules
local input_is_loaded
local function load_input()
if input_is_loaded then return
else
 local input_module, err
 input_module, err = modload ( "input" )
 if input_module == nil
 then
  error("we need the input module. Error message is:\n\r"..err,0) -- err contient le message d'erreur
 end
 input_module() -- define inpustring, inputinteger, inputfloat
 input_is_loaded = true
end

end

local math_is_loaded
local function load_math()
if math_is_loaded then return
else
 local math_module, err;
 math_module, err = modload ( "math" )
 if math_module == nil -- si il y a erreur
  then
   error("we need the math module. Error message is:\n\r"..err,0) -- err contient le message d'erreur
  end
 math_module() -- define global functions pow, sin, cos, tan, atan, asin, acos
 math_is_loaded = true
end
end


-- Math part

local function math_test1()
 clear 0
 cursor(1,1)
 print("sinus test (rad)\n\renter a value:")
 copypage(0,3) -- we save the screen

 local res

 repeat
  res = inputfloat(3,1)
  if res then
    cursor(4,1)
	print(sin(res))
	wait(150)
	copypage(3,0) -- clean the screen
  end
 until res == nil -- we want to exit

 copypage(2,0) -- the text of math_test

 wait_no_press(36)
-- we return to math_test's boucle
end

local function math_test2()
 clear 0
 cursor(1,1)
 print("pow(a,b) = a^b test\n\renter two values:")
 copypage(0,3) -- we save the screen

 local res1,res2

 repeat
  res1 = inputfloat(3,1)
  res2 = inputfloat(4,1)
  if res1 and res2 then
    cursor(5,1)
	print(pow(res1,res2))
	wait(150)
	copypage(3,0) -- clean the screen
  end
 until not(res1 and res2) -- we want to exit

 copypage(2,0) -- the text of math_test

 wait_no_press(36)
-- we return to math_test's boucle
end

local function math_test3()
 clear 0
 cursor(1,1)
 print("sqrt test\n\renter a value:")
 copypage(0,3) -- we save the screen

 local res

 repeat
  res = inputfloat(3,1)
  if res then
    cursor(4,1)
	print(misc.math("sqrt",res))
	wait(150)
	copypage(3,0) -- clean the screen
  end
 until res == nil -- we want to exit

 copypage(2,0) -- the text of math_test

 wait_no_press(36)
-- we return to math_test's boucle
end

local function math_test4()
 clear 0
 cursor(1,1)
 print("int test\n\renter a value:")
 copypage(0,3) -- we save the screen

 local res

 repeat
  res = inputfloat(3,1)
  if res then
    cursor(4,1)
	print(int(res))
	wait(150)
	copypage(3,0) -- clean the screen
  end
 until res == nil -- we want to exit

 copypage(2,0) -- the text of math_test

 wait_no_press(36)
-- we return to math_test's boucle
end


local function math_test()
 clear 0
 cursor(1,1)
 print(" Math Test\n\r\n\r You can test the accuracy of math functions")
 wait(200)

 load_math()
 load_input()

 clear 0
 cursor(1,1)
 print("1->sin\n\r2->pow\n\r3->sqrt\n\r4->intpart\n\r\n\resc:exit")
 copypage(0,2) -- we save the screen
 repeat
  wait(1)
  if key(6) then math_test1()
  elseif key(7) then math_test2()
  elseif key(8) then math_test3()
  elseif key(11) then math_test4()
  end
 until key(36)
 wait_no_press(36)
 copypage(1,0)
end


-- misc test

-- cube

-------------3D with a far point
local PTF = {x=96,y=32,z=80}
--The far point



function fix3D(x,y,z) -- dcale en fonction de z: x et y (3D) PTF est le point fixe sous forme de table.
local o=(z/PTF.z)
if o==0 then return x,y end
x=x+o*(PTF.x-x)
y=y+o*(PTF.y-y)
return x+0.5,y+0.5 --
end



local function misc_cube()
clear 0
cursor(1,1)
print("Blackandwhite mode")
wait(200)
local line=nbdraw.line
local cubex1,cubey1,cubez1=30,30,20
local cubex2,cubey2
local behindx1,behindy1,behindz1,behindx2,behindy2=30,30,20,50,50
local touche

repeat
clear 0
cubex2 = cubex1+20
cubey2 = cubey1+20
line(cubex1,cubey1,cubex2,cubey1)
line(cubex2,cubey1,cubex2,cubey2)
line(cubex1,cubey2,cubex2,cubey2)
line(cubex1,cubey1,cubex1,cubey2)

behindx1,behindy1=fix3D(cubex1,cubey1,cubez1)
behindx2,behindy2=fix3D(cubex2,cubey2,cubez1)


line(behindx1,behindy1,behindx2,behindy1)
line(behindx2,behindy1,behindx2,behindy2)
line(behindx1,behindy2,behindx2,behindy2)
line(behindx1,behindy1,behindx1,behindy2)

line(behindx1,behindy1,cubex1,cubey1)
line(behindx2,behindy1,cubex2,cubey1)
line(behindx1,behindy2,cubex1,cubey2)
line(behindx2,behindy2,cubex2,cubey2)
repeat
if key (37) and cubex1>1
then cubex1=cubex1-1 ;touche =1
elseif key (40) and cubex1<108
then cubex1=cubex1+1 ;touche =1 end
if key (39) and cubey1>1
then cubey1=cubey1-1 ;touche =1
elseif key (38) and cubey1<44
then cubey1=cubey1+1 ;touche =1 end
if touche==0 then wait(10) end
until touche==1 or key(36)
touche = 0
until key(36)

wait(15) -- prevent a bug

graydraw.setcolor(true)
graydraw.text(1,1,"gray mode")
refresh
wait(200)
line=graydraw.line
local rect = graydraw.rect

cubex1,cubey1,cubez1=30,30,20
behindx1,behindy1,behindz1,behindx2,behindy2=30,30,20,50,50

repeat
clear nil
cubex2 = cubex1+20
cubey2 = cubey1+20
rect(cubex1,cubey1,cubex2,cubey2,4,0)

behindx1,behindy1=fix3D(cubex1,cubey1,cubez1)
behindx2,behindy2=fix3D(cubex2,cubey2,cubez1)


rect(behindx1,behindy1,behindx2,behindy2,4,10)

line(behindx1,behindy1,cubex1,cubey1,4)
line(behindx2,behindy1,cubex2,cubey1,4)
line(behindx1,behindy2,cubex1,cubey2,4)
line(behindx2,behindy2,cubex2,cubey2,4)
refresh
repeat
if key (37) and cubex1>1
then cubex1=cubex1-1 ;touche =1
elseif key (40) and cubex1<108
then cubex1=cubex1+1 ;touche =1 end
if key (39) and cubey1>1
then cubey1=cubey1-1 ;touche =1
elseif key (38) and cubey1<44
then cubey1=cubey1+1 ;touche =1 end
if touche==0 then wait(10) end
until touche==1 or key(36)
touche = 0
until key(36)
misc.exit()

end



local function misc_scroll()
clear 0
cursor(1,1)
print("manual:\n\rleft-up-down-right:\n\rmove the screen\n\rf1-6 change color\n\r1-8:change speed")
wait(200)
graydraw.setcolor(true)
clear nil
local coul = 100
local dc=1
graydraw.rect(50,20,65,35,4,10)

repeat

if(key(37)) then
scrollx -dc,coul
elseif (key(40)) then
scrollx dc,coul
end
if(key(39)) then
scrolly -dc,coul
elseif (key(38)) then
scrolly dc,coul
end
if(key(6)) then dc=1
elseif (key(7)) then dc=2
elseif (key(8)) then dc=3
elseif (key(11)) then dc=4
elseif (key(12)) then dc=5
elseif (key(13)) then dc=6
elseif (key(16)) then dc=7
elseif (key(17)) then dc=8
elseif (key(45)) then coul=0
elseif (key(46)) then coul=1
elseif (key(47)) then coul=2
elseif (key(48)) then coul=3
elseif (key(49)) then coul=4
elseif (key(50)) then coul=5
elseif (key(41)) then coul=100
end
refresh
until key(36)
wait(10)
misc.exit()
end

local BAILOUT = 16

local function iterate(x,y)

	local cr = y-0.5
	local ci = x
	local zi = 0.0
	local zr = 0.0
	local i = 0
	local temp
	local zr2
	local zi2

	for i=0,12,1 do
		temp = zr * zi
		zr2 = zr*zr
		zi2 = zi*zi
		zr = zr2-zi2+cr
		zi = temp+temp+ci
		if (zi2+zr2 > BAILOUT) then
			return i
		end


	end
return 0
end

local function misc_mandelbrot()
	local px=1
	local py=1
	local pix = nbdraw.pixel
	clear 0
	cursor(1,16) print("mandel") wait(50)
	for y = -39, 24,1 do
		for x = -39, 38,1 do
			if (iterate(x/40.0, y/40) == 0) then
			pix(px,py,1)
			end

			px=px+1
			if key (36) then misc.exit() end
		end
		px=1
		py=py+1
	end
	cursor(2,16) print("end") wait(50)
	copypage(2,0)

end

local function misc_random()
local rand = misc.random
clear 0
cursor(1,1)
print("Nb of launchs(1-6):")
local DE={0,0,0,0,0,0}
local xx=inputinteger(2,1)
clear 0
local x
local pourc= xx/20
local B=pourc-1
for lance=0,xx,1 do
x=rand(6)+1
DE[x]=DE[x]+1
B=B+1
if B==pourc
then
B=0
clear 0
cursor(1,1)
print("done:",(lance/xx)*100,"%")
if key (36) then misc.exit() end
end
end
clear 0
cursor(1,1)
print("results:\n\r")
print("1:",DE[1],"\n\r")
print("2:",DE[2],"\n\r")
print("3:",DE[3],"\n\r")
print("4:",DE[4],"\n\r")
print("5:",DE[5],"\n\r")
print("6:",DE[6],"\n\r")
wait(300)
clear 0
cursor(1,1)
print("percentage :\n\r")
print("1:",DE[1]/xx,"\n\r")
print("2:",DE[2]/xx,"\n\r")
print("3:",DE[3]/xx,"\n\r")
print("4:",DE[4]/xx,"\n\r")
print("5:",DE[5]/xx,"\n\r")
print("6:",DE[6]/xx,"\n\r")
wait(300)
copypage(2,0)
end




local function misc_test()
 wait_no_press(7)
 clear 0
 cursor(1,1)
 print(" Misc Test\n\r")
 load_input()
 print("1->cube\n\r2->scroll\n\r3->mandelbrot\n\r4->random\n\resc:exit")
 copypage(0,2) -- we save the screen (will be erased if we use the gray mode)
 repeat
  wait(1)
  if key(6) then misc_cube()
  elseif key(7) then misc_scroll()
  elseif key(8) then misc_mandelbrot()
  elseif key(11) then misc_random()
  end
 until key(36)
 wait_no_press(36)
 copypage(1,0)
end











clear 0
cursor(1,1)
print(" Lua Test\n\r")
print("\n\r\n\r1->math test\n\r2->misc test\n\r\n\resc->exit")
copypage(0,1) -- we save the screen


repeat
wait(1)
if key(6) then math_test()
elseif key(7) then misc_test()
end
until key(36)

